# -*- coding: utf-8 -*-

import os
import struct
import json
from cesium.models import GPX_TRACK
from cesium.models import GPX_TRACK_POINTS
from django.db.models import Max, Min
import time
from datetime import date

def create_czml(request):

    trkid = request.POST.get('trkid', '')

    trackQuery = GPX_TRACK.objects.filter(id=trkid)[0]
    activity = trackQuery.type

    pointsQuery = GPX_TRACK_POINTS.objects.filter(trackid_id__exact=trkid)

    startTime = pointsQuery.aggregate(Min('time')).get('time__min').isoformat()
    endTime = pointsQuery.aggregate(Max('time')).get('time__max').isoformat()

    color_r = 0
    color_g = 0
    color_b = 0

    czmlString = '[{\n' \
        '"id" : "Vehicle",\n' \
        '"availability" : "' + startTime+'/' + endTime + '",\n' \
        '"billboard" : {' \
            '"image" : "resources/images/tracks/' + activity + '.png "\n' \
        '},' \
        '"path" : {\n' \
            '"color" : [{\n' \
                '"rgba" : [' + str(color_r) + ', ' + str(color_g) + ', ' + str(color_b) + ', 255]\n' \
            '}],\n' \
            '"width" : 2.0\n' \
        '},\n' \
        '"position" : {\n' \
            '"cartographicDegrees" : [\n'
    for p in pointsQuery:

        lon = p.lon
        lat = p.lat
        ele = p.elv
        time = p.time
        name = p.name

        czmlString += '"' + str(time.isoformat()) + '", ' + str(lon) + ', ' + str(lat) + ', ' + str(ele) + ',\n'

    czmlString = czmlString[:-2]
    czmlString += ']}\n' \
    '}]'

    message = 'Track ' + str(trkid) + ' wurde erfolgreich eingebunden.'
    success = True

    retMsg = '{"success": "' + str(success) + '" , "data":' + czmlString + '}'

    return retMsg
