# -*- coding: utf-8 -*-

import os
import struct
import logging
from django.core import serializers
from django.contrib.auth.models import User
from cesium.models import GPX_TRACK
from cesium.models import GPX_TRACK_POINTS
logger = logging.getLogger(__name__)

def get_track_profile(request):

    trkid = request.POST.get('trkid', '')

    if(request.user.id is not None):
        if trkid is not None:

            try:
                success = True
                message = 'Profildaten wurden erfolgreich geladen'

                trackProfile = GPX_TRACK_POINTS.objects.filter(trackid_id=trkid).order_by('dist')

                data = serializers.serialize("json", trackProfile, fields=('dist', 'elv', 'time'))

                logger.info("Successfully loaded track profile (id:{0})".format(trkid))

            except Exception as e:
                success = False
                message = 'Fehler' + str(e)

                logger.error("Error while loading track profile (id:{0}): {1}".format(trkid, e))

        else:
            success = False
            message = 'Sie sind nicht eingeloggt. Es konnten keine Tracks geladen werden.'

        if data is not None:
            retMsg = '{"success": "' + str(success) + '" , "msg":"' + message + '", "data":' + data + '}'
        else :
            retMsg = '{"success": "' + str(success) + '" , "msg":"' + message + '"}'

    return retMsg