from django.contrib.gis.db import models
from django.contrib.auth.models import User
from django.contrib.gis.geos import Point, GEOSGeometry

class GPX_TRACK(models.Model):

    userid = models.ForeignKey(
        User
    )
    name = models.CharField(
        null=True,
        blank=False,
        max_length=200
    )
    desc = models.CharField(
        null=True,
        blank=False,
        max_length=500
    )
    type = models.CharField(
        null=True,
        blank=False,
        max_length=50
    )
    length = models.FloatField(
        null=True,
        blank=False
    )

    def __unicode__(self):
        return self.name

class GPX_TRACK_POINTS(models.Model):

    trackid = models.ForeignKey(
        GPX_TRACK
    )
    name = models.CharField(
        null=True,
        blank=False,
        max_length=200
    )
    lon = models.FloatField(
        null=True,
        blank=False
    )
    lat = models.FloatField(
        null=True,
        blank=False
    )
    elv = models.FloatField(
        null=True,
        blank=False
    )
    time = models.DateTimeField(
        null=True,
        blank=False
    )
    cmt = models.CharField(
        null=True,
        blank=False,
        max_length=200
    )
    speed = models.FloatField(
        null=True,
        blank=False
    )
    sym = models.CharField(
        null=True,
        blank=False,
        max_length=200
    )
    hdop = models.FloatField(
        null=True,
        blank=False
    )
    vdop = models.FloatField(
        null=True,
        blank=False
    )
    pdop = models.FloatField(
        null=True,
        blank=False
    )
    dist = models.FloatField(
        null=True,
        blank=False
    )
    geom = models.PointField(srid=4326)

    objects = models.GeoManager()

    # Returns the string representation of the model.
    # On Python 3: def __str__(self):
    def __unicode__(self):
        return self.name