# Create your views here.
# Import django modules
import cgi
from django.shortcuts import render_to_response
from cesium.upload import upload_gpx
from cesium.getTracks import get_user_tracks
from cesium.getTrackDetails import get_track_details
from cesium.updateTrackDetails import update_track_details
from cesium.getTrackProfile import get_track_profile
from cesium.deleteTrack import delete_track
from cesium.createCzml import create_czml
from cesium.proxy import proxy_method
from django.http import HttpResponse
from django.http import StreamingHttpResponse

def index(request):
    'Cesium Client'
    return render_to_response('index.html', {
    })

def login(request):
    'Login',
    request.method == 'POST'
    if 'user' in request.POST:
        user_ID = request.POST.get('user', '')
    else:
        user_ID = None
    return render_to_response('login.json', {
        "USERID": user_ID,
        'attributes': {
            'imageryProvider': '"OpenStreetMap"',
            'name': '"OSM Mapnik"',
            'url': 'null',
            'fileExtension': 'null',
            'proxy': 'null',
            'extent': 'null',
            'maximumLevel': 'null',
            'credit': 'null'
        }
    })

def uploadGpx(request):
    'Upload GPX',
    if request and request.is_ajax:
        return HttpResponse(upload_gpx(request))
    else:
        return HttpRequest(status=400)

def getTracks(request):
    'Get user tracks',
    if request and request.is_ajax:
        return HttpResponse(get_user_tracks(request))
    else:
        return HttpRequest(status=400)

def getTrackDetails(request):
    'Get user tracks',
    if request and request.is_ajax:
        return HttpResponse(get_track_details(request))
    else:
        return HttpRequest(status=400)

def updateTrackDetails(request):
    'Get user tracks',
    if request and request.is_ajax:
        return HttpResponse(update_track_details(request))
    else:
        return HttpRequest(status=400)

def getTrackProfile(request):
    'Get track profile',
    if request and request.is_ajax:
        return HttpResponse(get_track_profile(request),
            mimetype='application/json')
    else:
        return HttpRequest(status=400)

def deleteTrack(request):
    'Delete a users track',
    if request and request.is_ajax:
        return HttpResponse(delete_track(request))
    else:
        return HttpRequest(status=400)

def createCzml(request):
    'Create CZML',
    if request and request.is_ajax:
        return HttpResponse(create_czml(request))
    else:
        return HttpRequest(status=400)

def proxy(request):
    'Proxy',
    if request and request.is_ajax:
        status, contentType, response = proxy_method(request)
        return HttpResponse(response, content_type=contentType, status=status)
    else:
        return HttpRequest(status=400)