# Create your views here.
# Import django modules
from django.shortcuts import render_to_response
from django.contrib.auth import authenticate, login, logout
from django.contrib.auth.models import User
from django.db.models import Q
from django.http import HttpResponse
from django.core.mail import send_mail
import json

def init_view(request):

    user = request.user
    username = request.user.username
    id = request.user.id

    if request.user is not None and username:
        print("User ist " + username)
    else:
        print("nicht eingeloggt")

    return render_to_response('login.json', {
        "userid": id,
        "username": username,
        'attributes': {
            'imageryProvider': '"BingMaps"',
            'name': '"Bing"',
            'url': 'null',
            'fileExtension': 'null',
            'extent': 'null',
            'maximumLevel': 18,
            'credit': '"terrestris"',
            'proxy': 'null'
        }
    })

def status_view(request):
    response_data = {}
    if request.user is not None and request.user.username:
        print("User ist " + request.user.username)
        response_data['username'] = request.user.username
        response_data['userid'] = request.user.id
    else:
        print("nicht eingeloggt")
        response_data['username'] = "Anonymous"
    return HttpResponse(json.dumps(response_data), mimetype="application/json")

def login_view(request):
    username = request.POST['user']
    password = request.POST['pass']
    response_data = {}
    userObject = {}

    user = authenticate(username=username, password=password)

    if user is not None:
        if user.is_active:
            login(request, user)

            # Replicate userobject TODO: --> there must be a better way --> Casting?!
            userObject['id'] = user.id
            userObject['last_login'] = str(user.last_login)
            userObject['is_superuser'] = user.is_superuser
            userObject['username'] = user.username
            userObject['firstname'] = user.first_name
            userObject['lastname'] = user.last_name
            userObject['email'] = user.email
            userObject['is_staff'] = user.is_staff
            userObject['is_active'] = user.is_active
            userObject['date_joined'] = str(user.date_joined)

            response_data['msg'] = 'Login OK'
            response_data['success'] = 'true'
            response_data['user'] = userObject

            print(response_data)
        else:
            response_data['msg'] = 'FailInactive'
            response_data['success'] = 'false'
    else:
        response_data['msg'] = 'Fail'
        response_data['success'] = 'false'

    return HttpResponse(json.dumps(response_data), content_type="application/json")

def logout_view(request):
    logout(request)
    response_data = {'success' : 'true'}
    return HttpResponse(json.dumps(response_data), mimetype="application/json")

def registration_view(request):
    first_name = request.POST['vorname']
    last_name = request.POST['nachname']
    username = request.POST['benutzername']
    password = request.POST['passwort']
    email = request.POST['email']

    # Filter for the given username, email.
    # If one of them is already taken, the
    # queryset will return atleast one entry.

    # username_in_use = User.objects.filter(username__iexact=username)
    # email_in_use = User.objects.filter(email__iexact=email)
    name_or_email_used = User.objects.filter(Q(username__iexact=username) | Q(email__iexact=email))

    # if username_in_use or email_in_use:
    if name_or_email_used:
        response_data = {'success' : 'false', 'msg' : 'Faildoubleuser'}
    else:
        # Generate a random password for the user
        #password = User.objects.make_random_password()

        # Create a new user object and save it in the database
        user = User.objects.create_user(username, email, password)
        user.first_name = first_name
        user.last_name = last_name
        user.is_active = True
        user.save()

        response_data = {'success' : 'true', 'msg' : 'OK'}

#        send_mail('Neue Anmeldung im Cesium-Client',
#                  'Hallo ' + username + ', \n Sie können sich ab sofort im Cesium-Client anmelden. Ihr Passwort: '+ password,
#                  'registration@gpext.de',
#                  [email],
#                  fail_silently=False)

        print(response_data)

    return HttpResponse(json.dumps(response_data), mimetype="application/json")
