/*global Ext, OpenLayers*/
/*jslint plusplus: true, sloppy: true, white: true*/

/**


 Published under the BSD license.

 All rights reserved.

 Redistribution and use in source and binary forms, with or without
 modification, are permitted provided that the following conditions are met:

 Redistributions of source code must retain the above copyright notice,
 this list of conditions and the following disclaimer.
 Redistributions in binary form must reproduce the above copyright
 notice, this list of conditions and the following disclaimer in the
 documentation and/or other materials provided with the distribution.
 Neither the name of the terrestris GmbH & Co. KG nor the names of its
 contributors may be used to endorse or promote products derived from
 this software without specific prior written permission.

 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGE.

 @author terrestris GmbH & Co. KG
 */

/**
 * The main application viewport, which displays the whole application
 * @extends Ext.Viewport
 */

Ext.define('ExtACe.view.Viewport', {
    extend : 'Ext.Viewport',
    xtype: 'v_viewport',
    requires : [
        'Ext.layout.container.Border',
        'Ext.example.*',

        'ExtACe.tools.perspectiveSplitButton',
        'ExtACe.tools.GpxUploadButton',
        'ExtACe.tools.LoginButton',
        'ExtACe.tools.RegistrationButton',
        'ExtACe.tools.ControlCenterButton',
        'ExtACe.tools.ToggleSouthPanelButton',

        'ExtACe.widgets.ViewerBox',
        'ExtACe.widgets.LayerTreePanel',
        'ExtACe.widgets.NominatimCombo',
        'ExtACe.widgets.TrackGridPanel',
        'ExtACe.widgets.TrackProfilePanel',
        'ExtACe.widgets.TrackDetailsPanel'
    ],

    /**
     *
     */
    layout: 'border',

    /**
     * the items
     */
    items: null,

    /**
     * The items defaults
     */
    defaults: {
        split: true
    },

    /**
     * initializes this component
     */
    initComponent: function () {
        var me = this;

        me.items = [{
            region: 'north',
            margins: '5 5 0 5',
            split: false,
            border: false,
            bodyStyle: {
                background: '#3892D3'
            },
            items: [{
                xtype: 'image',
                height: 70,
                border: false,
                style: {
                    float: 'right',
                    background: '#3892D3'
                },
                src: Ext.Loader.getPath('ExtACe') + '/../resources/images/header/header.png'
            }],
            bbar: [{
                xtype: 'tbfill'
            }, {
                xtype: 't_login_button'
            }, {
                xtype: 't_registration_button'
            }, {
                xtype: 't_controlcenter_button',
                hidden: true
            }]
        }, {
            region: 'west',
            margins: '5 0 5 5',
            title: 'Hintergrundkarte',
            collapsed: true,
            collapsible: true,
            width: 250,
            items: [{
                xtype: 'w_treepanel'
            }]
        }, {
            region: 'east',
            margins: '5 5 5 0',
            layout: 'border',
            title: 'Meine Tracks',
            defaults: {
                split: true
            },
            width: 300,
            items: [{
                xtype: 'w_track_grid',
                region: 'center'
            }, {
                xtype: 'w_track_details',
                height: 150,
                hidden: true,
                region: 'south'
            }]
        }, {
            region: 'center',
            margins: '5 0 5 0',
            layout: 'border',
            defaults: {
                split: true,
                border: false
            },
            tbar: [{
                xtype: 't_perspective_split_button'
            }, {
                xtype: 't_gpx_upload_button',
                disabled: true
            }, {
                xtype: 't_toggle_south_button'
            }, {
                xtype: 'tbfill'
            }, {
                xtype: 'w_nominatim_combo'
            }],
            items: [{
                region: 'center',
                xtype: 'w_viewerbox'
            }, {
                region: 'south',
                height: 150,
                hidden: true,
                xtype: 'w_track_profile'
            }]
        }];

        me.callParent(arguments);
    }
});